package networks;

import javax.swing.text.*;
import parser.*;
import java.util.*;
import java.net.*;
import javax.swing.text.html.*;
/**
 * Insert the type's description here.
 * Creation date: (3/8/2002 5:04:11 PM)
 * @author: Administrator
 */
public class ExciteWrapper extends SearchWrapper {
	public static final String EXCITESEARCH = "http://srch.excite.com/d/search/p/excite/?c=web&s=";
/**
 * Insert the method's description here.
 * Creation date: (3/11/2002 2:39:00 AM)
 */
public ExciteWrapper() {

	super();
}
/**
 * Insert the method's description here.
 * Creation date: (3/11/2002 2:39:00 AM)
 */
public ExciteWrapper(int n) {
	super(n);
	
}
/**
 * Extracts URLs from a query
 * Creation date: (7/24/01 1:20:57 AM)
 * @return SearchResultVector
 */
private SearchResultVector generateSearchResultInfo(HTMLDocument htmlDoc) {

	SearchResultVector searchResultList = new SearchResultVector();

	// Used to keep track of redundant URLs
	HashMap URL_list = new HashMap();
	HTMLDocumentParser p = new HTMLDocumentParser();
	p.setHTMLDoc(htmlDoc);

	String strTemp = null;
	String title = null;

	if (htmlDoc == null)
		return searchResultList;

	try {
		ElementIterator iterator = new ElementIterator(htmlDoc);
		Element elem;

		while ((elem = iterator.next()) != null) {
			SimpleAttributeSet sas = 
				(SimpleAttributeSet) elem.getAttributes().getAttribute(HTML.Tag.A); 
			if (sas != null) {
				if (sas.getAttribute(HTML.Attribute.HREF) != null) {
					strTemp = sas.getAttribute(HTML.Attribute.HREF).toString();
					// Filter out URLs within Google domain
					if (strTemp.startsWith("http://www5.overture")){
						title = p.getTextFromElement(elem);
						// Check for redundancy
						if (!(URL_list.containsKey(strTemp))) {
							URL_list.put(strTemp, strTemp);
							while ((elem = iterator.next()) != null)
								if (elem.getName().equals("span")){
									elem = iterator.next();
									break;
								}
							if (elem == null)
								break;
							String text = new String();
							text = p.getTextFromElement(elem);

							try {
								if(!text.startsWith("http") && (text.length() !=0))
								    text = "http://" + text;
								new URL(text);  
							} catch (Exception ee) {
								 text = strTemp;
							}							
							searchResultList.add(
								new SearchResult(new URL(text), title, strTemp.toString())); 
						}
					}
				}
			}
		}

	} catch (Exception e) {
		System.out.println(e.toString() + " in generateSearchResultInfo(HTMLDocument)"); 
	}

	return searchResultList;
}
/**
 * Performs a regular search query.
 *
 * Search terms must be added to the searchWordList
 * by use of the addSearchWord(String) method.
 */
public SearchResultVector performQuery() {
	StringBuffer sbURL = new StringBuffer(EXCITESEARCH + generateQueryString() + "&n="+ get_numMaxResults());
	SearchResultVector sr = new SearchResultVector();
	
	HTMLDocument hdoc = null;
	
	if(get_searchWordList().size() == 0) return sr;

	try {

		URL url = new java.net.URL(sbURL.toString());

		hdoc = sendQuery(url);
	
		sr = generateSearchResultInfo(hdoc);
	
	} catch (Exception e) {
		System.out.println(e + " in performQuery()");
	}

	return sr;

}
}
