package networks;

import java.util.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import parser.*;



/**
 * Wrapper class for the Google Search Engine
 */

 public abstract class SearchWrapper {

	
	private int _maxReturnCount = 10;
	private Vector _searchWordList = null;




	
	
	
	









/**
 * GoogleWrapper constructor comment.
 */
public SearchWrapper() {
	super();
}
/**
 * GoogleWrapper constructor comment.
 */
public SearchWrapper(int n) {
	super();

	set_maxResults(n);
	_searchWordList = new Vector();

	
}
/**
 * Used to add a search term before performQuery method is called
 */
public void addSearchWord(String word) {

	get_searchWordList().add(word);

}
/**
 * Clears the search word list for a new query
 */
public void clearSearchWordList() {

	get_searchWordList().clear();

}
/**
 * 
 * 
 * @return java.lang.String
 */
public String generateQueryString() {

	StringBuffer sb = new StringBuffer();

	if(get_searchWordList().size() == 0) return "";
	
	// Add search terms to the query
	for (int i = 0; i < get_searchWordList().size(); i++) {
		sb.append((String) get_searchWordList().elementAt(i));
		sb.append("+");
	}
	// Delete the "+" from the end of the string
	sb.deleteCharAt(sb.length() - 1);

	return sb.toString();
}
/**
 * Insert the method's description here.
 * Creation date: (8/8/01 11:39:37 PM)
 * @return int
 */
public int get_numMaxResults() {
	return _maxReturnCount;
}
/**
 * Insert the method's description here.
 * Creation date: (3/11/2002 12:04:35 AM)
 * @return java.util.Vector
 */
java.util.Vector get_searchWordList() {
	return _searchWordList;
}
/**
 * Insert the method's description here.
 * 
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	
	
	GoogleWrapper a = new GoogleWrapper(8);

	a.addSearchWord("body");
	a.addSearchWord("solutions");
	SearchResultVector sr =	a.performQuery();

	for(int i=0; i < sr.size(); i++) {
		SearchResult s = (SearchResult) sr.elementAt(i);
		System.out.println(s.getURL().toString() + "  "+ s.getTitle());
	}
	

	
	System.exit(0);
	
	
	
	}
/**
 * Performs a regular search query.
 *
 * Search terms must be added to the searchWordList
 * by use of the addSearchWord(String) method.
 */
public abstract SearchResultVector performQuery();
/**
 * Creates an HTMLDocument for the specified search query URL
 * Creation date: (7/23/01 8:56:21 PM)
 * @return javax.swing.text.html.HTMLDocument
 */

public HTMLDocument sendQuery(URL aURL)  {

	try {

		URLConnection conn = aURL.openConnection();

		// Work around for Google's "Automated Agent" block
		conn.setRequestProperty("User-Agent","Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0;)");
	
		HTMLDocument HTMLDoc = new HTMLDocument();
		HTMLEditorKit editorKit = new HTMLEditorKit();
		HTMLDoc = (HTMLDocument) editorKit.createDefaultDocument();
		HTMLDoc.putProperty("IgnoreCharsetDirective", Boolean.TRUE);
		Reader HTMLReader = new InputStreamReader(conn.getInputStream());
		editorKit.read(HTMLReader, HTMLDoc, 0);
		HTMLDoc.setBase(aURL);

		return HTMLDoc;
		
	} catch (NoRouteToHostException e1) {
		//System.err.println("Internet connection lost");
	} catch (MalformedURLException e2) {
		//System.err.println("Bad URL passed");
	} catch (BadLocationException e3) {
		//System.err.println("Bad Location Exception");
	} catch (IOException e4) {
		//System.err.println("IOException: connection closed");
	} catch (EmptyStackException e5){
		//System.out.println("Empty Stack Exception. Continue...");
	} 

	return null;

}
/**
 * Sets the maximum number of search terms to return
 * Creation date: (8/8/01 11:39:37 PM)
 * @param new_numResults int
 */
public void set_maxResults(int new_numResults) {
	_maxReturnCount = new_numResults;
}
/**
 * Insert the method's description here.
 * Creation date: (3/11/2002 12:04:35 AM)
 * @param new_searchWordList java.util.Vector
 */
public void set_searchWordList(java.util.Vector new_searchWordList) {
	_searchWordList = new_searchWordList;
}}