package networks;

import javax.swing.text.*;
import parser.*;
import java.util.*;
import java.net.*;
import javax.swing.text.html.*;
/**
 * Insert the type's description here.
 * Creation date: (3/8/2002 5:04:11 PM)
 * @author: Administrator
 */
public class YahooWrapper extends SearchWrapper {

/**
 * YahooWrapper constructor comment.
 */
public YahooWrapper() {
	super();
}
/**
 * YahooWrapper constructor comment.
 * @param n int
 */
public YahooWrapper(int n) {
	super(n);
}
/**
 * Extracts URLs from a query
 * Creation date: (7/24/01 1:20:57 AM)
 * @return SearchResultVector
 */
private SearchResultVector generateSearchResultInfo(HTMLDocument htmlDoc) {

	SearchResultVector searchResultList = new SearchResultVector();

	// Used to keep track of redundant URLs
	HashMap URL_list = new HashMap();
	HTMLDocumentParser p = new HTMLDocumentParser();
	p.setHTMLDoc(htmlDoc);

	String strTemp = null;
	String title = null;

	if (htmlDoc == null)
		return searchResultList;

	try {
		ElementIterator iterator = new ElementIterator(htmlDoc);
		Element elem;

		while ((elem = iterator.next()) != null) {
			SimpleAttributeSet sas = 
				(SimpleAttributeSet) elem.getAttributes().getAttribute(HTML.Tag.A); 
			if (sas != null) {
				if (sas.getAttribute(HTML.Attribute.HREF) != null) {
					strTemp = sas.getAttribute(HTML.Attribute.HREF).toString();
					// Filter out URLs within Google domain
					if (!(strTemp.startsWith("/")
						|| strTemp.startsWith("http://www.yahoo.com")
						|| strTemp.startsWith("http://rd.yahoo.com")
						|| strTemp.startsWith("http://search.yahoo.com")
						|| strTemp.startsWith("http://dir.yahoo.com")
						|| strTemp.startsWith("http://help.yahoo.com")
						|| strTemp.startsWith("http://toolbar.google.com"))
						&& strTemp.startsWith("http")) {
						title = p.getTextFromElement(elem);
						// Check for redundancy
						if (!(URL_list.containsKey(strTemp))) {
							URL_list.put(strTemp, strTemp);
							strTemp = strTemp.substring(strTemp.indexOf("*") + 1);
							while ((elem = iterator.next()) != null)
								if (elem.getName().equals(HTML.Tag.BR.toString()))
									break;
							if (elem == null)
								break;
							elem = iterator.next();
							String text = new String();
							text = p.getTextFromElement(elem);

							try {
								elem = iterator.next();
								if (elem != null) {
									Enumeration e = elem.getAttributes().getAttributeNames();
									while (e.hasMoreElements())
										if (e.nextElement().toString().equals("font-weight")) {
											int startOffset = elem.getStartOffset();
											while (((elem = iterator.next()) != null) && elem.getName().equals("content"));
											int length = elem.getEndOffset() - startOffset;
											text += htmlDoc.getText(startOffset, length);
										}
								}

							} catch (Exception e) {
								System.out.println(e);
							}
							try {
								StringTokenizer st = new StringTokenizer(text, ".");
								if (st.countTokens() >= 2){
								if(!text.startsWith("http") && (text.length() !=0))
								    text = "http://" + text;
								new URL(text);
								}else  text = strTemp;
							} catch (Exception ee) {
								 text = strTemp;
							}							
							searchResultList.add(
								new SearchResult(new URL(text), title, strTemp.toString())); 
						}
					}
				}
			}
		}

	} catch (Exception e) {
		System.out.println(e.toString() + " in generateSearchResultInfo(HTMLDocument)"); 
	}

	return searchResultList;
}
/**
 * Performs a regular search query.
 *
 * Search terms must be added to the searchWordList
 * by use of the addSearchWord(String) method.
 */
public SearchResultVector performQuery() {
	StringBuffer sbURL = new StringBuffer(YAHOOSEARCH + generateQueryString() + "&n="+ get_numMaxResults());
	SearchResultVector sr = new SearchResultVector();
	
	HTMLDocument hdoc = null;
	
	if(get_searchWordList().size() == 0) return sr;

	try {

		URL url = new java.net.URL(sbURL.toString());

		hdoc = sendQuery(url);
	
		sr = generateSearchResultInfo(hdoc);
	
	} catch (Exception e) {
		System.out.println(e + " in performQuery()");
	}

	return sr;

}
	public static final String YAHOOSEARCH = "http://search.yahoo.com/bin/search?p=";}